//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//file constants.h
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifndef CONSTANTS_H
#define CONSTANTS_H

//change this to 0 if you do not want inline assembler optimization
//in ida.nextSolution()
#define INLINE 1

#define MAXSOLVERLENGTH 24

//maximal value in pruning table
#define MAXPRUN 12

#define MAXPOWER 3
#define MAXAXIS 5


#define N_MAXGEN 25
#define N_MOVE 18
#define N_SYM 48

#define N_CORNER 8

#define N_EDGE 12
#define N_TWIST 3
#define N_FLIP 2

#define N_CPOS 40320
#define N_CTWIST 2187
#define N_EFLIP 2048
#define	N_SLICE 495
#define N_SORTSLICE (24*N_SLICE)

#define N_FLIPSLICE 64430
#define N_PHASE1 (N_FLIPSLICE*N_CTWIST)

#define FLIPSLICE "flipslice.rep"
#define FLIPSLICE_SYM "flipslice.sym"
#define SYM_MULT "symmult.data"
#define SYM_INV "syminv.data"
#define MOVE_CONJ "move.conj"

#define FLIPSLICE_MOVE "flipslice.move"
#define CTWIST_MOVE "twist.move"
#define CPOS_MOVE "cpos.move"
#define SORTSLICE_MOVE "sslice.move"

#define PHASE1_PRUN "phase1.prun"

#define TWIST_CONJ "twist.conj"


enum corner {urf,ufl,ulb,ubr,drb,dfr,dlf,dbl};
enum edge {fr,fl,bl,br,uf,ub,db,df,ur,dr,dl,ul};
enum Move {U1,R1,F1,D1,L1,B1,U2,R2,F2,D2,L2,B2,U3,R3,F3,D3,L3,B3,LAST};

#endif